Index: issm/branches/trunk-jpl-damage/src/c/Container/Inputs.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/Container/Inputs.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/Container/Inputs.cpp	(revision 12878)
@@ -4,5 +4,5 @@
  */
 
-/*Headers: {{{1*/
+/*Headers: {{{*/
 #ifdef HAVE_CONFIG_H
 	#include <config.h>
@@ -25,10 +25,10 @@
 
 /*Object constructors and destructor*/
-/*FUNCTION Inputs::Inputs(){{{1*/
+/*FUNCTION Inputs::Inputs(){{{*/
 Inputs::Inputs(){
 	return;
 }
 /*}}}*/
-/*FUNCTION Inputs::~Inputs(){{{1*/
+/*FUNCTION Inputs::~Inputs(){{{*/
 Inputs::~Inputs(){
 	return;
@@ -37,5 +37,5 @@
 
 /*Object management*/
-/*FUNCTION Inputs::GetInputValue(bool* pvalue,int enum-type){{{1*/
+/*FUNCTION Inputs::GetInputValue(bool* pvalue,int enum-type){{{*/
 void Inputs::GetInputValue(bool* pvalue,int enum_type){
 
@@ -57,5 +57,5 @@
 		/*we could not find an input with the correct enum type. No defaults values were provided, 
 		 * error out: */
-		_error_("could not find input with enum type %i (%s)",enum_type,EnumToStringx(enum_type));
+		_error2_("could not find input with enum type " << enum_type << " (" << EnumToStringx(enum_type) << ")");
 	}
 
@@ -65,5 +65,5 @@
 }
 /*}}}*/
-/*FUNCTION Inputs::GetInputValue(int* pvalue,int enum-type){{{1*/
+/*FUNCTION Inputs::GetInputValue(int* pvalue,int enum-type){{{*/
 void Inputs::GetInputValue(int* pvalue,int enum_type){
 
@@ -85,5 +85,5 @@
 		/*we could not find an input with the correct enum type. No defaults values were provided, 
 		 * error out: */
-		_error_("could not find input with enum type %i (%s)",enum_type,EnumToStringx(enum_type));
+		_error2_("could not find input with enum type " << enum_type << " (" << EnumToStringx(enum_type) << ")");
 	}
 
@@ -93,6 +93,6 @@
 }
 /*}}}*/
-/*FUNCTION Inputs::GetInputValue(double* pvalue,int enum-type){{{1*/
-void Inputs::GetInputValue(double* pvalue,int enum_type){
+/*FUNCTION Inputs::GetInputValue(IssmDouble* pvalue,int enum-type){{{*/
+void Inputs::GetInputValue(IssmDouble* pvalue,int enum_type){
 
 	vector<Object*>::iterator object;
@@ -113,5 +113,5 @@
 		/*we could not find an input with the correct enum type. No defaults values were provided, 
 		 * error out: */
-		_error_("could not find input with enum type %i (%s)",enum_type,EnumToStringx(enum_type));
+		_error2_("could not find input with enum type " << enum_type << " (" << EnumToStringx(enum_type) << ")");
 	}
 
@@ -121,6 +121,6 @@
 }
 /*}}}*/
-/*FUNCTION Inputs::GetInputAverage{{{1*/
-void Inputs::GetInputAverage(double* pvalue,int enum_type){
+/*FUNCTION Inputs::GetInputAverage{{{*/
+void Inputs::GetInputAverage(IssmDouble* pvalue,int enum_type){
 
 	vector<Object*>::iterator object;
@@ -141,5 +141,5 @@
 		/*we could not find an input with the correct enum type. No defaults values were provided, 
 		 * error out: */
-		_error_("could not find input with enum type %i (%s)",enum_type,EnumToStringx(enum_type));
+		_error2_("could not find input with enum type " << enum_type << " (" << EnumToStringx(enum_type) << ")");
 	}
 
@@ -149,5 +149,5 @@
 }
 /*}}}*/
-/*FUNCTION Inputs::AddInput{{{1*/
+/*FUNCTION Inputs::AddInput{{{*/
 int  Inputs::AddInput(Input* in_input){
 
@@ -175,5 +175,5 @@
 }
 /*}}}*/
-/*FUNCTION Inputs::ChangeEnum{{{1*/
+/*FUNCTION Inputs::ChangeEnum{{{*/
 void  Inputs::ChangeEnum(int oldenumtype,int newenumtype){
 
@@ -205,6 +205,6 @@
 }
 /*}}}*/
-/*FUNCTION Inputs::ConstrainMin{{{1*/
-void  Inputs::ConstrainMin(int constrain_enum, double minimum){
+/*FUNCTION Inputs::ConstrainMin{{{*/
+void  Inputs::ConstrainMin(int constrain_enum, IssmDouble minimum){
 	   
 	Input* constrain_input=NULL; 
@@ -213,5 +213,5 @@
 
 	/*some checks: */
-	if(!constrain_input) _error_(" input %s could not be found!",EnumToStringx(constrain_enum));
+	if(!constrain_input) _error2_("input " << EnumToStringx(constrain_enum) << " could not be found!");
 
 	/*Apply ContrainMin: */
@@ -219,9 +219,9 @@
 }
 /*}}}*/
-/*FUNCTION Inputs::InfinityNorm{{{1*/
-double Inputs::InfinityNorm(int enumtype){
-
-	/*Output*/
-	double norm;
+/*FUNCTION Inputs::InfinityNorm{{{*/
+IssmDouble Inputs::InfinityNorm(int enumtype){
+
+	/*Output*/
+	IssmDouble norm;
 
 	/*Get input*/
@@ -240,9 +240,9 @@
 }
 /*}}}*/
-/*FUNCTION Inputs::Max{{{1*/
-double Inputs::Max(int enumtype){
-
-	/*Output*/
-	double max;
+/*FUNCTION Inputs::Max{{{*/
+IssmDouble Inputs::Max(int enumtype){
+
+	/*Output*/
+	IssmDouble max;
 
 	/*Get input*/
@@ -254,5 +254,5 @@
 	}
 	else{
-		_error_("Input %s not found",EnumToStringx(enumtype));
+		_error2_("Input " << EnumToStringx(enumtype) << " not found");
 	}
 
@@ -261,9 +261,9 @@
 }
 /*}}}*/
-/*FUNCTION Inputs::MaxAbs{{{1*/
-double Inputs::MaxAbs(int enumtype){
-
-	/*Output*/
-	double max;
+/*FUNCTION Inputs::MaxAbs{{{*/
+IssmDouble Inputs::MaxAbs(int enumtype){
+
+	/*Output*/
+	IssmDouble max;
 
 	/*Get input*/
@@ -275,5 +275,5 @@
 	}
 	else{
-		_error_("Input %s not found",EnumToStringx(enumtype));
+		_error2_("Input " << EnumToStringx(enumtype) << " not found");
 	}
 
@@ -282,9 +282,9 @@
 }
 /*}}}*/
-/*FUNCTION Inputs::Min{{{1*/
-double Inputs::Min(int enumtype){
-
-	/*Output*/
-	double min;
+/*FUNCTION Inputs::Min{{{*/
+IssmDouble Inputs::Min(int enumtype){
+
+	/*Output*/
+	IssmDouble min;
 
 	/*Get input*/
@@ -296,5 +296,5 @@
 	}
 	else{
-		_error_("Input %s not found",EnumToStringx(enumtype));
+		_error2_("Input " << EnumToStringx(enumtype) << " not found");
 	}
 
@@ -303,9 +303,9 @@
 }
 /*}}}*/
-/*FUNCTION Inputs::MinAbs{{{1*/
-double Inputs::MinAbs(int enumtype){
-
-	/*Output*/
-	double min;
+/*FUNCTION Inputs::MinAbs{{{*/
+IssmDouble Inputs::MinAbs(int enumtype){
+
+	/*Output*/
+	IssmDouble min;
 
 	/*Get input*/
@@ -317,5 +317,5 @@
 	}
 	else{
-		_error_("Input %s not found",EnumToStringx(enumtype));
+		_error2_("Input " << EnumToStringx(enumtype) << " not found");
 	}
 
@@ -324,5 +324,5 @@
 }
 /*}}}*/
-/*FUNCTION Inputs::GetInput{{{1*/
+/*FUNCTION Inputs::GetInput{{{*/
 Input* Inputs::GetInput(int enum_name){
 
@@ -341,5 +341,5 @@
 }
 /*}}}*/
-/*FUNCTION Inputs::DeleteInput{{{1*/
+/*FUNCTION Inputs::DeleteInput{{{*/
 int  Inputs::DeleteInput(int enum_type){
 
@@ -361,5 +361,5 @@
 }
 /*}}}*/
-/*FUNCTION Inputs::DuplicateInput{{{1*/
+/*FUNCTION Inputs::DuplicateInput{{{*/
 void  Inputs::DuplicateInput(int original_enum,int new_enum){
 
@@ -369,5 +369,5 @@
 	/*Make a copy of the original input: */
 	original=(Input*)this->GetInput(original_enum);
-	if(!original)_error_("could not find input with enum: %s",EnumToStringx(original_enum)); 
+	if(!original)_error2_("could not find input with enum: " << EnumToStringx(original_enum)); 
 	copy=(Input*)original->copy();
 
@@ -379,5 +379,5 @@
 }
 /*}}}*/
-/*FUNCTION Inputs::SpawnTriaInputs{{{1*/
+/*FUNCTION Inputs::SpawnTriaInputs{{{*/
 Inputs* Inputs::SpawnTriaInputs(int* indices){
 
@@ -405,6 +405,6 @@
 }
 /*}}}*/
-/*FUNCTION Inputs::AXPY{{{1*/
-void  Inputs::AXPY(int MeshYEnum, double scalar, int MeshXEnum){
+/*FUNCTION Inputs::AXPY{{{*/
+void  Inputs::AXPY(int MeshYEnum, IssmDouble scalar, int MeshXEnum){
 	   
 	Input* xinput=NULL;
@@ -416,6 +416,6 @@
 
 	/*some checks: */
-	if(!xinput) _error_(" input %s could not be found!",EnumToStringx(MeshXEnum));
-	if(!yinput) _error_(" input %s could not be found!",EnumToStringx(MeshYEnum));
+	if(!xinput) _error2_("input " << EnumToStringx(MeshXEnum) << " could not be found!");
+	if(!yinput) _error2_("input " << EnumToStringx(MeshYEnum) << " could not be found!");
 
 	/*Apply AXPY: */
@@ -423,5 +423,5 @@
 }
 /*}}}*/
-/*FUNCTION Inputs::Configure{{{1*/
+/*FUNCTION Inputs::Configure{{{*/
 void Inputs::Configure(Parameters* parameters){
 
Index: issm/branches/trunk-jpl-damage/src/c/Container/Inputs.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/Container/Inputs.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/Container/Inputs.h	(revision 12878)
@@ -23,28 +23,28 @@
 	public:
 
-		/*constructors, destructors: {{{1*/
+		/*constructors, destructors: {{{*/
 		Inputs();
 		~Inputs();
 
 		/*}}}*/
-		/*numerics: {{{1*/
+		/*numerics: {{{*/
 		int     AddInput(Input* in_input);
 		void    ChangeEnum(int enumtype,int new_enumtype);
-		void    ConstrainMin(int constrain_enum, double minimum);
+		void    ConstrainMin(int constrain_enum, IssmDouble minimum);
 		int     DeleteInput(int enum_type);
 		void    DuplicateInput(int original_enum,int new_enum);
 		Input*  GetInput(int enum_name);
 		Inputs* SpawnTriaInputs(int* indices);
-		void    AXPY(int MeshYEnum, double scalar, int MeshXEnum);
-		double  InfinityNorm(int enumtype);
-		double  Max(int enumtype);
-		double  MaxAbs(int enumtype);
-		double  Min(int enumtype);
-		double  MinAbs(int enumtype);
+		void    AXPY(int MeshYEnum, IssmDouble scalar, int MeshXEnum);
+		IssmDouble  InfinityNorm(int enumtype);
+		IssmDouble  Max(int enumtype);
+		IssmDouble  MaxAbs(int enumtype);
+		IssmDouble  Min(int enumtype);
+		IssmDouble  MinAbs(int enumtype);
 		
-		void GetInputAverage(double* pvalue, int enum_type);
+		void GetInputAverage(IssmDouble* pvalue, int enum_type);
 		void GetInputValue(bool* pvalue,int enum_type);
 		void GetInputValue(int* pvalue,int enum_type);
-		void GetInputValue(double* pvalue,int enum_type);
+		void GetInputValue(IssmDouble* pvalue,int enum_type);
 
 		void Configure(Parameters* parameters);
Index: issm/branches/trunk-jpl-damage/src/c/Container/Loads.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/Container/Loads.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/Container/Loads.cpp	(revision 12878)
@@ -4,5 +4,5 @@
  */
 
-/*Headers: {{{1*/
+/*Headers: {{{*/
 #ifdef HAVE_CONFIG_H
 	#include <config.h>
@@ -25,5 +25,5 @@
 
 /*Object constructors and destructor*/
-/*FUNCTION Loads::Loads(){{{1*/
+/*FUNCTION Loads::Loads(){{{*/
 Loads::Loads(){
 	enum_type=LoadsEnum;
@@ -31,5 +31,5 @@
 }
 /*}}}*/
-/*FUNCTION Loads::~Loads(){{{1*/
+/*FUNCTION Loads::~Loads(){{{*/
 Loads::~Loads(){
 	return;
@@ -38,5 +38,5 @@
 
 /*Numerics:*/
-/*FUNCTION Loads::Configure{{{1*/
+/*FUNCTION Loads::Configure{{{*/
 void Loads::Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters){
 
@@ -53,5 +53,5 @@
 }
 /*}}}*/
-/*FUNCTION Loads::NumberOfLoads{{{1*/
+/*FUNCTION Loads::NumberOfLoads{{{*/
 int Loads::NumberOfLoads(void){
 
@@ -74,5 +74,5 @@
 }
 /*}}}*/
-/*FUNCTION Loads::SetCurrentConfiguration{{{1*/
+/*FUNCTION Loads::SetCurrentConfiguration{{{*/
 void Loads::SetCurrentConfiguration(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters){
 
Index: issm/branches/trunk-jpl-damage/src/c/Container/Loads.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/Container/Loads.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/Container/Loads.h	(revision 12878)
@@ -20,9 +20,9 @@
 	public:
 
-		/*constructors, destructors: {{{1*/
+		/*constructors, destructors: {{{*/
 		Loads();
 		~Loads();
 		/*}}}*/
-		/*numerics: {{{1*/
+		/*numerics: {{{*/
 		void  Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters);
 		int   NumberOfLoads(void);
Index: issm/branches/trunk-jpl-damage/src/c/Container/Materials.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/Container/Materials.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/Container/Materials.cpp	(revision 12878)
@@ -4,5 +4,5 @@
  */
 
-/*Headers: {{{1*/
+/*Headers: {{{*/
 #ifdef HAVE_CONFIG_H
 	#include <config.h>
@@ -25,5 +25,5 @@
 
 /*Object constructors and destructor*/
-/*FUNCTION Materials::Materials(){{{1*/
+/*FUNCTION Materials::Materials(){{{*/
 Materials::Materials(){
 	enum_type=MaterialsEnum;
@@ -31,5 +31,5 @@
 }
 /*}}}*/
-/*FUNCTION Materials::~Materials(){{{1*/
+/*FUNCTION Materials::~Materials(){{{*/
 Materials::~Materials(){
 	return;
@@ -38,5 +38,5 @@
 
 /*Object management*/
-/*FUNCTION Materials::Configure{{{1*/
+/*FUNCTION Materials::Configure{{{*/
 void Materials::Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters){
 
Index: issm/branches/trunk-jpl-damage/src/c/Container/Materials.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/Container/Materials.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/Container/Materials.h	(revision 12878)
@@ -19,9 +19,9 @@
 	public:
 
-		/*constructors, destructors: {{{1*/
+		/*constructors, destructors: {{{*/
 		Materials();
 		~Materials();
 		/*}}}*/
-		/*numerics: {{{1*/
+		/*numerics: {{{*/
 		void  Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters);
 		/*}}}*/
Index: issm/branches/trunk-jpl-damage/src/c/Container/Nodes.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/Container/Nodes.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/Container/Nodes.cpp	(revision 12878)
@@ -4,5 +4,5 @@
  */
 
-/*Headers: {{{1*/
+/*Headers: {{{*/
 #ifdef HAVE_CONFIG_H
 	#include <config.h>
@@ -25,5 +25,5 @@
 
 /*Object constructors and destructor*/
-/*FUNCTION Nodes::Nodes(){{{1*/
+/*FUNCTION Nodes::Nodes(){{{*/
 Nodes::Nodes(){
 	enum_type=NodesEnum;
@@ -31,5 +31,5 @@
 }
 /*}}}*/
-/*FUNCTION Nodes::~Nodes(){{{1*/
+/*FUNCTION Nodes::~Nodes(){{{*/
 Nodes::~Nodes(){
 	return;
@@ -38,5 +38,5 @@
 
 /*Numerics*/
-/*FUNCTION Nodes::Configure{{{1*/
+/*FUNCTION Nodes::Configure{{{*/
 void Nodes::Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters){
 
@@ -53,5 +53,5 @@
 }
 /*}}}*/
-/*FUNCTION Nodes::DistributeDofs{{{1*/
+/*FUNCTION Nodes::DistributeDofs{{{*/
 void  Nodes::DistributeDofs(int analysis_type,int setenum){
 
@@ -84,5 +84,5 @@
 	 * cpus by the total last dofs of the previus cpu, starting from 0.
 	 * First: get number of dofs for each cpu*/
-	alldofcount=(int*)xmalloc(num_procs*sizeof(int));
+	alldofcount=xNew<int>(num_procs);
 	#ifdef _HAVE_MPI_
 	MPI_Gather(&dofcount,1,MPI_INT,alldofcount,1,MPI_INT,0,MPI_COMM_WORLD);
@@ -113,6 +113,6 @@
 	numnodes=this->NumberOfNodes(analysis_type);
 	if(numnodes*maxdofspernode){
-		truedofs=   (int*)xcalloc(numnodes*maxdofspernode,sizeof(int)); //initialize to 0, so that we can pick up the max
-		alltruedofs=(int*)xcalloc(numnodes*maxdofspernode,sizeof(int));
+		truedofs=   xNewZeroInit<int>(numnodes*maxdofspernode); //initialize to 0, so that we can pick up the max
+		alltruedofs=xNewZeroInit<int>(numnodes*maxdofspernode);
 	}
 
@@ -139,10 +139,10 @@
 
 	/* Free ressources: */
-	xfree((void**)&alldofcount);
-	xfree((void**)&truedofs);
-	xfree((void**)&alltruedofs);
-}
-/*}}}*/
-/*FUNCTION Nodes::FlagClones{{{1*/
+	xDelete<int>(alldofcount);
+	xDelete<int>(truedofs);
+	xDelete<int>(alltruedofs);
+}
+/*}}}*/
+/*FUNCTION Nodes::FlagClones{{{*/
 void  Nodes::FlagClones(int analysis_type){
 
@@ -158,6 +158,6 @@
 
 	/*Allocate ranks: */
-	ranks=(int*)xmalloc(numnodes*sizeof(int));
-	minranks=(int*)xmalloc(numnodes*sizeof(int));
+	ranks=xNew<int>(numnodes);
+	minranks=xNew<int>(numnodes);
 
 	for(i=0;i<numnodes;i++)ranks[i]=num_procs; //no cpu can have rank num_procs. This is the maximum limit.
@@ -190,10 +190,10 @@
 
 	/*Free ressources: */
-	xfree((void**)&ranks); 
-	xfree((void**)&minranks);
-
-}
-/*}}}*/
-/*FUNCTION Nodes::MaxNumDofs{{{1*/
+	xDelete<int>(ranks); 
+	xDelete<int>(minranks);
+
+}
+/*}}}*/
+/*FUNCTION Nodes::MaxNumDofs{{{*/
 int   Nodes::MaxNumDofs(int analysis_type,int setenum){
 
@@ -225,5 +225,5 @@
 }
 /*}}}*/
-/*FUNCTION Nodes::NumberOfDofs{{{1*/
+/*FUNCTION Nodes::NumberOfDofs{{{*/
 int   Nodes::NumberOfDofs(int analysis_type,int setenum){
 
@@ -259,5 +259,5 @@
 }
 /*}}}*/
-/*FUNCTION Nodes::NumberOfNodes(){{{1*/
+/*FUNCTION Nodes::NumberOfNodes(){{{*/
 int Nodes::NumberOfNodes(void){
 
@@ -287,5 +287,5 @@
 }
 /*}}}*/
-/*FUNCTION Nodes::NumberOfNodes(analysis){{{1*/
+/*FUNCTION Nodes::NumberOfNodes(analysis){{{*/
 int Nodes::NumberOfNodes(int analysis_type){
 
@@ -326,5 +326,5 @@
 }
 /*}}}*/
-/*FUNCTION Nodes::Ranks{{{1*/
+/*FUNCTION Nodes::Ranks{{{*/
 void   Nodes::Ranks(int* ranks,int analysis_type){
 
@@ -352,5 +352,5 @@
 }
 /*}}}*/
-/*FUNCTION Nodes::SetCurrentConfiguration{{{1*/
+/*FUNCTION Nodes::SetCurrentConfiguration{{{*/
 void Nodes::SetCurrentConfiguration(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters){
 
Index: issm/branches/trunk-jpl-damage/src/c/Container/Nodes.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/Container/Nodes.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/Container/Nodes.h	(revision 12878)
@@ -13,9 +13,9 @@
 	public:
 
-		/*constructors, destructors: {{{1*/
+		/*constructors, destructors: {{{*/
 		Nodes();
 		~Nodes();
 		/*}}}*/
-		/*numerics: {{{1*/
+		/*numerics: {{{*/
 		void  Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters);
 		void  DistributeDofs(int analysis_type,int SETENUM);
